Below, you'll find some Linux code which reads a SysEx file (for example from /dev/midi) and saves every program to a file. The second file can be used to send one program to your KORG to replace the current program.

As a side effect it prints all program names.

Werner Van Belle




#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

/*
 *      ALL PROGS
 */

static unsigned char allprogs[1024*1024];
static int aantalprogs=0;

int addprog(unsigned char* prog)
{
   /* check duplicates */
   int idx=0,i;
   assert(prog);
/*   printf("# = %d\n",aantalprogs);*/
   while(idx<aantalprogs)
     {
/*      for(i=0; i<154;i++)
          {
             printf("%d|%d ",allprogs[idx*164+10+i],prog[10+i]);
          }
        printf("\n\n");
*/      if (memcmp(&allprogs[idx*164+10],&prog[10],154)==0)
          {
             printf("duplicate prog %s, %s\n",getprogname(&allprogs[idx*164]),getprogname(prog));
             return 0;
          }
        idx++;
     }
   memcpy(&allprogs[aantalprogs*164],prog,164);
   aantalprogs++;
/*   printf("added prog %s\n",getprogname(prog));*/
   return 1;
}

/*void writedata(FILE* f)
{
   assert(f);
   fwrite(&alldata,164,aantalprogs,f);
   return;
}*/

/*
 * lezen syx data
 */

union bitpitser
{
   struct sb
     {
        unsigned char bit0:1;
        unsigned char bit1:1;
        unsigned char bit2:1;
        unsigned char   bit3:1;
        unsigned char   bit4:1;
        unsigned char   bit5:1;
        unsigned char   bit6:1;
        unsigned char   bit7:1;
     } bit;
   unsigned char value;
};

union placer
{
   unsigned char value;
   struct st
     {
        unsigned char bit0_7: 7;
        unsigned char zeven: 1;
     } bit;
};

static int next=7;
static union placer ch[8];

void fatal(char* tekst)
{
   printf("fatal: %s\n",tekst);
   fflush(stdout);
   exit(50);
}

int charplz()
{
   int c;
   c=getchar();
   if (c==-1) fatal("EOF");
   return c;
}

int dplz()
{
   if (next==7)
     {
        union bitpitser bits;
        next=0;
        bits.value=charplz();
        ch[0].value=charplz();
        ch[1].value=charplz();
        ch[2].value=charplz();
        ch[3].value=charplz();
        ch[4].value=charplz();
        ch[5].value=charplz();
        ch[6].value=charplz();
        ch[0].bit.zeven=bits.bit.bit0;
        ch[1].bit.zeven=bits.bit.bit1;
        ch[2].bit.zeven=bits.bit.bit2;
        ch[3].bit.zeven=bits.bit.bit3;
        ch[4].bit.zeven=bits.bit.bit4;
        ch[5].bit.zeven=bits.bit.bit5;
        ch[6].bit.zeven=bits.bit.bit6;
     }
   return ch[next++].value;
}

unsigned char prog[164];
void readprog()
{
   int i;
   for(i=0;i<=163;i++)
     {
        prog[i]=dplz();
     }
}

char* getprogname()
{
   char str[11];
   strncpy(str,prog,10);
   str[10]=0;
   return strdup(str);
}

enum model_type {
undefined =0,
   Xkorg = 1,
Nkorg = 2
} model;

void saveprog(char* name)
{
   FILE *f;
   int trynr=0;
   char newname[50];
   char* n,*usename;
   n=name;
   while(*n)
     {
        if ((*n)=='/') *n='\\';
        if ((*n)=='\'') *n='_';
        n++;
     }
   n--;
   while(n>name && *n==' ') *n=0;
   sprintf(newname,"%d:%s",trynr++,name);
   usename=newname;
   while (f=fopen(usename,"rb"))
     {
        fclose(f);
        sprintf(newname,"%d:%s",trynr++,name);
        usename=newname;
     }
   f=fopen(usename,"wb");
   if (!f) printf("failed while openening %s\n",name);
   assert(f);
   fwrite(prog,164,1,f);
   fclose(f);
}

void recvprogdump()
{
   int c,i;
   c=charplz();
   assert(c==0);
   next=7;
   for(i=0;i<=99;i++)
     {
        char* progname;
        readprog();
        progname=getprogname();
/*      printf("bank A%d: %s\n",i,progname);*/
        if (addprog(prog))
          saveprog(progname);
     }
   if (model==Nkorg)
   for(i=0;i<=99;i++)
     {
        char* progname;
        readprog();
        progname=getprogname();
        printf("bank B%d: %s\n",i,progname);
        /* write to a file */
        addprog(prog);
        saveprog(progname);
     }
}

void main(void)
{
   int c;
   c=charplz();
   if (c!=0xf0) fatal("wrong header 2");
   c=charplz();
   if (c!=0x42) fatal("wrong header 1");
   c=charplz();
   if (c!=0x30) fatal("wrong header 3");
   c=charplz();
   if (c==0x36)
     {
        model=Xkorg;
        printf("X-korg\n");
     }
   else if (c==0x35)
     {
        model=Nkorg;
        printf("N-korg\n");
     }
   if (!model) fatal("wrong model");
   c=charplz();
   if (c==0x4c)
     {
        printf("program parameter dump\n");
        recvprogdump();
     }
}
