Below, you'll find some Linux code which can be used to send one program to your KORG to replace the current program.

Werner Van Belle




#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

union bitpitser
{
   struct sb
     {
        unsigned char bit0:1;
        unsigned char bit1:1;
        unsigned char bit2:1;
        unsigned char   bit3:1;
        unsigned char   bit4:1;
        unsigned char   bit5:1;
        unsigned char   bit6:1;
        unsigned char   bit7:1;
     } bit;
   unsigned char value;
};

union placer
{
   unsigned char value;
   struct st
     {
        unsigned char bit0_7: 7;
        unsigned char zeven: 1;
     } bit;
};

static int next=0;
static union placer ch[8];

void fatal(char* tekst)
{
   printf("fatal: %s\n",tekst);
   fflush(stdout);
   exit(50);
}

static FILE* mpu=NULL;
void writechar(unsigned char c)
{
   if (!mpu)
     {
        mpu=fopen("/dev/midi00","wb");
        assert(mpu);
     }
   fputc(c,mpu);
   fflush(mpu);
/*   fflush(stdout);
   sleep(1);*/
}

void stop()
{
   union bitpitser bits;
   bits.bit.bit0=ch[0].bit.zeven;
   bits.bit.bit1=ch[1].bit.zeven;
   bits.bit.bit2=ch[2].bit.zeven;
   bits.bit.bit3=ch[3].bit.zeven;
   bits.bit.bit4=ch[4].bit.zeven;
   bits.bit.bit5=ch[5].bit.zeven;
   bits.bit.bit6=ch[6].bit.zeven;
   bits.bit.bit7=0;
   writechar(bits.value);
   ch[0].bit.zeven=0;
   ch[1].bit.zeven=0;
   ch[2].bit.zeven=0;
   ch[3].bit.zeven=0;
   ch[4].bit.zeven=0;
   ch[5].bit.zeven=0;
   ch[6].bit.zeven=0;
   if (next>0) writechar(ch[0].value);
   if (next>1) writechar(ch[1].value);
   if (next>2) writechar(ch[2].value);
   if (next>3) writechar(ch[3].value);
   if (next>4) writechar(ch[4].value);
   if (next>5) writechar(ch[5].value);
   if (next>6) writechar(ch[6].value);
   ch[0].value=0;
   ch[1].value=0;
   ch[2].value=0;
   ch[3].value=0;
   ch[4].value=0;
   ch[5].value=0;
   ch[6].value=0;
   next=0;
}

void sd(unsigned char c)
{
   if (next==7)
     {
        stop();
     }
   ch[next++].value=c;
}

unsigned char prog[164];
void writeprog()
{
   int i;
   for(i=0;i<=163;i++)
     {
        sd(prog[i]);
     }
   stop();
}

void main(int argc, char* argv[])
{
   int i;
   FILE* f;
   writechar(0xF0);
   writechar(0x42);
   writechar(0x30);
   writechar(0x35);
   writechar(0x4e);
   writechar(0x03);
   writechar(0x00);
   writechar(0xF7);

   writechar(0xF0);
   writechar(0x42);
   writechar(0x30);
   writechar(0x35);
   writechar(0x40);
   assert(argc==2);
   f=fopen(argv[1],"rb");
   fread(prog,164,1,f);
   fclose(f);
   writeprog();
   writechar(0xF7);

   sleep(1);

   writechar(0xF0);
   writechar(0x42);
   writechar(0x30);
   writechar(0x35);
   writechar(0x41);
   writechar(0x01);
   writechar(0x00);
   writechar(0x00);
   writechar(0x00);
   writechar(0xF7);

   writechar(0xF0);
   writechar(0x42);
   writechar(0x30);
   writechar(0x35);
   writechar(0x4e);
   writechar(0x02);
   writechar(0x00);
   writechar(0xF7);

}
